;*******************************************
;*         (C)06/1998 Easy Soft            *
;*******************************************

	.TITLE	"PLYTKA ZEGARA STEROWNIKA MIKROPROCESOROWEGO"
	.VERS	"ST6215"
	.ROMSIZE 2


A	.DEF	0FFH	;Akumulator
X	.DEF	080H!m	;Rejestr indeksowy X
Y	.DEF	081H!m	;Rejestr indeksowy Y
V	.DEF	082H!m	;Rejestr danych V
W	.DEF	083H!m	;Rejestr danych W
DRA	.DEF	0C0H!m	;Rejestr danych portu A
DRB	.DEF	0C1H	;Rejestr danych portu B
DRC	.DEF	0C2H	;Rejestr danych portu C
DDRA	.DEF	0C4H	;Rejestr kierunku portu A
DDRB	.DEF	0C5H	;Rejestr kierunku portu B
DDRC	.DEF	0C6H	;Rejestr kierunku portu C
IOR	.DEF	0C8H	;Rejestr trybu pracy przerwa
DRWR	.DEF	0C9H	;Rejestr danych okna ROM
ORA	.DEF	0CCH!m	;Rejestr trybu pracy portu A
ORB	.DEF	0CDH	;Rejestr trybu pracy portu B
ORC	.DEF	0CEH	;Rejestr trybu pracy portu C
ADR	.DEF	0D0H	;Rejestr danych przetwornika A/D.
ADCR	.DEF	0D1H	;Rejestr kontrolny przetw.A/D
PSC	.DEF	0D2H	;Rejestr preskalera zegara
TCR	.DEF	0D3H	;Rejestr licznika zegara
TSCR	.DEF	0D4H	;Rejestr kontrolny statusu zegara
WDR	.DEF	0D8H	;Rejestr ukadu Watchdog

;czas aktualny
MINAKT	.DEF	084H	;Licznik minut
SECAKT	.DEF	085H	;Licznik sekund
HOURAKT	.DEF	086H	;Licznik godzin
;czasy zacze
MINAL1	.DEF	087H	;Ustawione minuty alarmu 1
HOURAL1	.DEF	088H	;Ustawione godziny alarmu 1
MINAL2	.DEF	089H	;Ustawione minuty alarmu 2
HOURAL2	.DEF	08AH	;Ustawione godziny alarmu 2
;czasy wycze
MOFFAL1	.DEF	09CH	;Minuty wyczenia alarmu 1
HOFFAL1	.DEF	09DH	;Godziny wyczenia alarmu 1
MOFFAL2	.DEF	09EH	;Minuty wyczenia alarmu 2
HOFFAL2	.DEF	09FH	;Godziny wyczenia alarmu 2
;licznik sekund pauzy
SECSCNT	.DEF	0A0H

;czas wywietlany
MIN	.DEF	08BH	;Minuty wywietlane
HOUR	.DEF	08CH	;Godziny wywietlane

IRQCNT	.DEF	08DH	;Licznik przerwa TIMERA
STADISP	.DEF	08EH	;Stan wywietlacza LED w kodzie BCD
ONDISP	.DEF	092H	;Stan zmiennej okrela,co aktualnie jest wywietlane
			; b7|b6 |b5 |b4 |b3 |b2 |b1 |b0
			;---|---|---|---|---|---|---|---
			; x   x   x   x   0   0   0   1   - wyw.jest aktualny czas
			; x   x   x   x   0   0   1   0   - wyw.jest stan alarmu 1
			; x   x   x   x   0   1   0   0   - wyw.jest stan alarmu 2
			; x   x   x   x   1   0   0   0   - wyw.s sekundy
STALED	.DEF	093H	;Stan diod wieccych LED na panelu
			;b0="GOT"/b1="P1"/b2="P2"/b3="ZA/WY"
STAKBD	.DEF	094H	;Stan klawiatury
			;b0="Z"/b1="P1"/b2="P2"/b3="-"/b4="+"/b5="ZA/WY"
STAPRG	.DEF	095H	;Status wykonywania programow PROG.1 i PROG.2
			;b0=1:PROGRAM 1 akt.
			;b1=1:PROGRAM 2 akt.
			;b2=0:PROGR.1,zaczenie 0,5h,..=1:PROGR.1,zaczenie 1h
			;b3=0:PROGR.2,zaczenie 0,5h,..=1:PROGR.2,zaczenie 1h
			;b4=1:ustawianie czasu lub programu-zaczenie alarmu zabronione
			;b5=1:alarm nie moe wycza przekanika
;--- dopisane w celu wygaszania wywietlacza --------
			;b6=1:wywietlacz wyczony
CNT1	.DEF	096H	;Liczniki pomocnicze (konwersja BCD itp.)
CNT2	.DEF	097H
COPY_A	.DEF	098H	;Kopia akumulatora w czasie obsugi przerwania zegarowego
COPY_PA	.DEF	099H	;Kopia stanu portu PA
COPY_PB	.DEF	09AH	;Kopia stanu portu PB
LOOPCNT	.DEF	09BH	;Licznik wej w procedur obsugi klawiatury

.ORG	880H
;segmenty  ->	.gfedcba	;Wzorzec wywietlanej cyfry (1-segment zapalony,0-zgaszony)
DIG_0	.BYTE	10111111B	;
DIG_1	.BYTE	10000110B	;   ----------
DIG_2	.BYTE	11011011B	;  |    A     |
DIG_3	.BYTE	11001111B	;  |   ---    |
DIG_4	.BYTE	11100110B	;  | F|   |B  |
DIG_5	.BYTE	11101101B	;  |   -G-    |
DIG_6	.BYTE	11111101B	;  | E|   |C  |
DIG_7	.BYTE	10000111B	;  |   ---  *H|
DIG_8	.BYTE	11111111B	;  |    D     |
DIG_9	.BYTE	11101111B	;   ----------
DIG_B	.BYTE	10000000B	;

;Czstotliwo przerwa w Hz
ONESEC	.EQU	75		;Ilo przerwa TIMER'a przypadajca
				;na jedn sekund

;Dane dla procedury CLRRAM
STARAM	.EQU	084H		;Pocztek pamici RAM
ENDRAM	.EQU	0BFH		;Koniec pamici RAM

;Kody wczajce poszczeglne cyfry (bity s negowane przez ULN2003)
DIGOFF	.EQU	00001111B	;Wyczenie wszystkich cyfr
DIGON1	.EQU	10001111B	;Waczenie wyw.jednostek
DIGON2	.EQU	01001111B	; - / / - dziesitek
DIGON3	.EQU	00101111B	; - / / - setek
DIGON4	.EQU	00011111B	; - / / - tysicy

;Kody stanw klawiatury w odniesieniu do STAKBD
PLUS	.EQU	00000001B
MINUS	.EQU	00000010B
ON_OFF	.EQU	00000100B

CLOCK	.EQU	00001000B
PROG_1	.EQU	00010000B
PROG_2	.EQU	00100000B

;Opnienia dla obsugi klawiatury (liczba wej do danej procedury)
DELAY1	.EQU	10		;do uruchomienia funkcji zadziaania klawisza
DELAY2	.EQU	120		;do funkcji autorepeat

;Pauza autozaczenia/wyczenia w sekundach
PSECS	.EQU	20


;Wektory przerwa
.ORG	0FF0H
IT_ADC	NOP				;Przerwanie z przetw.A/D
	RETI				;
IT_TMR	JP	TMR_IRQ			;Przerwanie ukadu zegarowego
IT_PBC	NOP				;Przerwanie z portu B lub C
	RETI
IT_PA	NOP				;Przerwanie z portu A
	RETI				;
	NOP				;Zarezerwowane
	NOP				;
	NOP				;
	NOP				;
NMI	NOP				;Przerwanie niemaskowalne
	RETI				;
RES	JP	INIT			;Wektor obsugi programu po RESET


;Pocztek programu gwnego,inicjalizacja rejestrw,programowanie trybw pracy
.ORG	890H
INIT	RETI				;Koniec obsugi przerw.po reset
	LDI	WDR,0FEH		;Zaadowanie do licznika WDR wart.0FEh
	SET	0,WDR			;Uaktywnienie WATCHDOG'a

	LDI	TCR,07DH		;Licznik TIMER'a=125
	LDI	TSCR,06EH		;ETI=1,preskaler=64
	CLR	ADCR			;Wyczenie przetw.A/D

	LDI	IOR,070H		;Zezwolenie na przyjmowanie przerwa


	LDI	DDRA,0FFH		;PA0..7 -push pull output
	LDI	ORA,0FFH
	LDI	DRA,07FH

	LDI	DDRB,0C7H		;PB0,1,2-standard open drain output
	CLR	ORB			;PB3,4,5-no pull up,no irq input
	LDI	DRB,0FFH		;PB6,7-push pull output

	LDI	DDRC,0FFH		;PC4..7-push pull output
	LDI	ORC,0FFH
	CALL	DIGSOFF			;Wyczenie wywietlaczy

	LDI	DRWR,022H		;Ustawienie adresu okna danych na 880h
	CALL	CLRRAM			;Zerowanie pamici RAM

	CALL	SETCLK			;Ustawienie bitu odpowiadajcego za wyw.
					;aktualnego czasu
MAIN	CALL	WYSW			;Wywietlenie cyfr i stanu diod LED
	CALL	KLAW			;Odczytanie stanu klawiatury
	RES	4,STAPRG		;Przed wejciem do rozpoznania podprogramu obsugi
					;zeruj STAPRG(b4) umoliwiajc dziaanie programw 1/2
	CALL	AKCJA			;Reakcja na nacinicie klawisza
	JRS	4,STAPRG,MAIN		;Jeeli ustawiana jest godzina/program,to nie wolno 
					;zacza przekanika
	CALL	ALARM			;Sprawdzenie w.czasowego
	JP	MAIN


;Wyczenie wywietlacza
DIGSOFF	LDI	DRC,DIGOFF
	LDI	COPY_PA,0FFH
	JRS	7,DRA,DIGSO_1
	RES	7,COPY_PA
DIGSO_1	LD	A,COPY_PA
	LD	DRA,A
	RET	


;Wywietlenie stanu diod LED oraz czasu aktualnego/alarmu
WYSW	LDI	WDR,0FEH		;Zabezpieczenie przed RESET'em przez ukad Watchdog'a
	CALL	WYSWLED			;Wywietlenie stanu diod LED
	JRR	6,STAPRG,WYSW_0		;Jeli b6=1,to mona wywietla cyfry
	CALL	DIGSOFF
	RET				;i powrt

WYSW_0	CALL	COWYSW			;Procedura w zalenoci od stanu zmiennej ONDISP
					;przenosi do MIN i HOUR czasy alarmw lub czas akt.
	CALL	H2D			;Zamiana MIN i HOUR na BCD, wynik w STADISP
	LDI	X,STADISP		;Do X adres zmiennej zaw.stan wywietlacza
					;w kodzie BCD
	CALL	WYSW_1			;Wywietlenie:
	CALL	L_1			; -jednostki minut
	CALL	WYSW_2
	CALL	L_10			; -dziesitki minut
	INC	X
	CALL	WYSW_1
	CALL	L_100			; -jednostki godzin
	CALL	WYSW_2
	CALL	L_1000			; -dziesitki godzin
	RET

WYSW_1	LD	A,(X)			;Wyznaczenie modszej czci bajtu
	ANDI	A,00001111B
	JP	WYSW_3
WYSW_2	LD	A,(X)			;Wyznaczenie starszej czci bajtu
	ANDI	A,11110000B
	ADDI	A,0			;Kasowanie flagi CARRY bo nie jest potrzebna przy
	RLC	A			;rotacji rejestru
	RLC	A
	RLC	A
	RLC	A
	RLC	A
WYSW_3	ADDI	A,40H
	LD	Y,A
	LD	A,(Y)
	RET

;Przepisanie do zmiennych HOUR,MIN danych w zalenoci od stanu
;komrki ONDISP (b0=1:czas akt./b1=1:prog.1/b2=1:prog.2).HOUR i MIN poddawane
;s konwersji BCD i wywietlane na wywietlaczu zegara.
;W zalenoci od stanu zmiennych STAPRG i ONDISP ustawiana jest warto bitu
;zapalajcego led "GOTOWE" (tzn.w trakcie realizacji programu).
;ONDISP.GODZINA*(STAPRG.PROG1+STAPRG.PROG2)
;ONDISP.PROGRAM1*STAPRG.PROG1
;ONDISP.PROGRAM2*STAPRG.PROG2
COWYSW	RES	0,STALED
	CALL	STAPAUS			;Sprawdzenie licznika pauzy
	JRR	0,ONDISP,COWYS_1
COWYS_3	LD	A,HOURAKT
	LD	HOUR,A
	LD	A,MINAKT
	LD	MIN,A
	LD	A,STAPRG		;Czy LED "GOTOWY" ma swieci (PRG.1+PRG.2)?
	ANDI	A,3H			;Maskowanie b2-b7
	JRZ	COWYS_8
	JRS	5,STAPRG,COWYS_8	;Kolejny warunek:jeli alarm nie moe wycza przek.
	SET	0,STALED		;to LED "GOTOWY" ma by zgaszony
COWYS_8	LD	A,IRQCNT		;Mrugajca kropka dziesitna - wyjcie TIMER
	CPI	A,37
	JRC	COWYS_7
	CALL	POINTON
	JP	COWYS_4
COWYS_7	CALL	POINTOF
COWYS_4	RET
COWYS_1	JRR	1,ONDISP,COWYS_2
	CALL	POINTON			;Kropka dziesitna nieruchoma
	LD	A,HOURAL1
	LD	HOUR,A
	LD	A,MINAL1
	LD	MIN,A
	LD	A,STAPRG		;LED "GOTOWY"?(PRG.1)
	JRR	0,STAPRG,COWYS_5
	SET	0,STALED
COWYS_5	RET
COWYS_2	JRR	2,ONDISP,COWYS_6
	CALL	POINTON			;Kropka dziesitna nieruchoma
	LD	A,HOURAL2
	LD	HOUR,A
	LD	A,MINAL2
	LD	MIN,A
	LD	A,STAPRG		;LED "GOTOWY"?(PRG.2)
	JRR	1,STAPRG,COWYS_A
	SET	0,STALED
COWYS_A	RET
COWYS_6	JRR	3,ONDISP,COWYS_3
	CALL	POINTON			;Wywietlenie licznika sekund
	CLR	HOUR
	LD	A,SECAKT
	LD	MIN,A
	LD	A,STAPRG		;Czy LED "GOTOWY" ma swieci (PRG.1+PRG.2)?
	ANDI	A,3H			;Maskowanie b2-b7
	JRZ	COWYS_9
	JRS	5,STAPRG,COWYS_9	;Kolejny warunek:jeli alarm nie moe wycza przek.
	SET	0,STALED		;to LED "GOTOWY" ma by zgaszony
COWYS_9	RET


;Jeeli licznik pauzy=czas pauzy to wyczenie wywietlania (b6 w staprg na "1")
STAPAUS	LD	A,SECSCNT		;Zaadowanie do A licznika pauzy
	SUBI	A,PSECS			;Czy secscnt=psecs?
	JRNZ	STAPA_1
	CALL	SETCLK			;Jeli tak,to wcz zegar
	SET	6,STAPRG		;Jeli tak,to wcz wywietlanie
STAPA_1	RET


;Wczenie i wyczenie wyjcia TIMER
POINTOF	RES	4,TSCR
	RET

POINTON	SET	4,TSCR
	RET

;Wywietlanie poszczeglnych cyfr wraz z wygaszaniem zera nieznaczcego
;na pozycji dziesitek godzin:akumulator zawiera cyfr do wywietlenia
					;Sprawdzenie stanu bitu "za/wy"
LLL	LD	COPY_PA,A		;B7 w akumulatorze jest 1-wynika to z wzorca cyfry
	JRS	3,STALED,LLL_1
	RES	7,COPY_PA
LLL_1	LD	A,COPY_PA
	LD	DRA,A
	RET

L_1	CALL	LLL			;Wywietlenie cyfry jednostek minut
	LDI	DRC,DIGON1
	CALL	PAUSE
	JP	L_RET
L_10	CALL	LLL			;Wywietlenie cyfry dziesitek minut
	LDI	DRC,DIGON2
	CALL	PAUSE
	JP	L_RET
L_100	CALL	LLL			;Wywietlenie cyfry jednostek godzin
	LDI	DRC,DIGON3
	CALL	PAUSE
	JP	L_RET
					;Wywietlenie cyfry dziesitek godzin
L_1000	LD	COPY_PA,A		;Zapamitanie akumulatora
	LDI	Y,40H			;Do rej.Y adres wzorca "0"
	SUB	A,(Y)			;Czy akumulator zawiera wzorzec "0"?
	JRZ	L_1001			;Jeli tak,to zaaduj wzorzec "BLANK"
	JP	L_1002			;Jeli nie,to odtwrz stan akum.i wywietl
L_1001	LDI	Y,4AH			;Adres wzorca "BLANK"
	LD	A,(Y)
	LD	COPY_PA,A
L_1002	LD	A,COPY_PA		;Odtworzenie a na podst.kopii
	CALL	LLL
	LDI	DRC,DIGON4
	CALL	PAUSE
L_RET	CALL	DIGSOFF			;Wyczenie cyfr wywietlacza
	RET

PAUSE	LDI	CNT2,0DFH		;Opnienie dla lepszej czytelnoci cyfr
PAUSE_1	DEC	CNT2
	JRNZ	PAUSE_1
	RET


;Konwersja MIN i HOUR na BCD,wynik umieszczany jest w STADISP
H2D	LDI	WDR,0FEH		;Zabezpieczenie przed RESET'em przez ukad Watchdog'a
	LD	A,MIN			;Konwersja minut na BCD
	LDI	X,STADISP
	CALL	H2D_1
	LD	A,HOUR			;Konwersja godzin na BCD
	INC	X
	CALL	H2D_1
	RET

;Liczba do konwersji w A,wynik zapamitany pod adresem wsk.przez X
H2D_1	CLR	CNT1
H2D_2	SUBI	A,10			;Liczymy 10 w liczbie
	JRC	H2D_3			;i dokd daj si odejmowa,dotd
	INC	CNT1			;liczymy wystpienia 10 (CNT1)
	JP	H2D_2
H2D_3	ADDI	A,10			;Uzupenienie przepenienia
	LD	V,A			;Zapamitanie modszej czeci liczby
	LD	A,CNT1			;A <- CNT1
	SLA	A			;A <- A*16
	SLA	A
	SLA	A
	SLA	A
	ADD	A,V			;Suma modszej i starszej czeci liczby
	LD	(X),A			;Zapamitanie pod adresem X
	RET


;Wywietlenie stanu diod LED
WYSWLED	LDI	WDR,0FEH		;Zabezpieczenie przed RESET'em przez ukad Watchdog'a
	LD	A,DRB
	LD	COPY_PB,A
					;Rozpatrywanie poszcz.bitw STALED
	SET	2,COPY_PB
	JRR	0,STALED,WLED_1		;Dioda "GOTOWY"
	RES	2,COPY_PB
WLED_1	SET	0,COPY_PB
	JRR	1,STALED,WLED_2		;Dioda "PROGRAM 1"
	CALL	LEDPRG1
WLED_2	SET	1,COPY_PB
	JRR	2,STALED,WLED_3		;Dioda "PROGRAM 2"
	CALL	LEDPRG2
WLED_3	JRR	3,STALED,WLED_4		;Wyjcie "ZACZONY/WYCZONY"
	SET	7,DRA
	JP	WLED_5
WLED_4	RES	7,DRA
WLED_5	LD	A,COPY_PB
	LD	DRB,A
	RET

;Obsuga migotania LED "PROGRAM 1" (dioda ma migota,jeli STAPRG(2)="1")
LEDPRG1	JRS	2,STAPRG,LPRG1_1
	RES	0,COPY_PB
	RET
LPRG1_1	JRS	0,SECSCNT,LPRG1_2	;Jeli SECSCNT(0)=1,to zga diod
	RES	0,COPY_PB		;Jeli SECSCNT(0)=0,to zapal diod
	RET
LPRG1_2	SET	0,COPY_PB
	RET

;Obsuga migotania LED "PROGRAM 2" (dioda ma migota,jeli STAPRG(3)="1")
LEDPRG2	JRS	3,STAPRG,LPRG2_1
	RES	1,COPY_PB
	RET
LPRG2_1	JRS	0,SECSCNT,LPRG2_2	;Jeli SECSCNT(0)=1,to zga diod
	RES	1,COPY_PB		;Jeli SECSCNT(1)=0,to zapal diod
	RET
LPRG2_2	SET	1,COPY_PB
	RET

;Obsuga przerwania zegarowego,zliczanie "tick'w" zegara
TMR_IRQ	LDI	TCR,07DH		;Rozpoczcie nowego odliczania
	RES	7,TSCR
	LD	COPY_A,A		;Zapamitanie zawartoci akumulatora
	INC	IRQCNT			;Zwikszamy licznik przerwa o 1
	LD	A,IRQCNT		;Czy to ju 75 powtrze(75Hz)?
	CPI	A,ONESEC
	JRZ	TMR_1			;Jeli tak,zwiksz licznik sekund
	JP	TIRQEND
TMR_1	CLR	IRQCNT			;Kasowanie licznika powtrze
	INC	SECSCNT			;Zwikszenie licznika pauzy (licznik ten liczy do 
					;przepenienia,zerowany i sprawdzany w odpow.procedurach)
	INC	SECAKT			;Zwikszenie licznika sekund
	LD	A,SECAKT		;Czy to ju 60 sekund(minuta)?
	CPI	A,60
	JRZ	TMR_2			;Jeli tak,zwiksz licznik minut
	JP	TIRQEND
TMR_2	CLR	SECAKT			;Kasowanie licznika sekund
	INC	MINAKT			;Zwikszenie licznika minut
	LD	A,MINAKT		;Czy to ju 60 minut(godzina)?
	CPI	A,60
	JRZ	TMR_3			;Jeli tak,to zwiksz licznik godzin
	JP	TIRQEND
TMR_3	CLR	MINAKT			;Skasuj licznik minut
	INC	HOURAKT			;Zwiksz licznik godzin
	LD	A,HOURAKT		;Czy miny ju 24 godziny(doba)?
	CPI	A,24
	JRZ	TMR_4			;Jeli tak,zacznij zliczanie od nowa
	JP	TIRQEND
TMR_4	CLR	HOURAKT
TIRQEND	LD	A,COPY_A
	RETI


;Odczyt stanu klawiatury (PB3,4,5 -WIERSZE(NO PU)/PB6,7 -KOLUMNY(PP))
KLAW	LDI	WDR,0FEH		;Zabezpieczenie przed RESET'em przez ukad Watchdog'a
	LD	A,DRB
	LD	COPY_PB,A
	RES	6,COPY_PB		;"0" dla kolumny 1
	SET	7,COPY_PB		;"1" w kolumnie 2
	LD	A,COPY_PB
	LD	DRB,A
	LD	A,DRB			;Ponowny odczyt DRB po wystawieniu
	COM	A			;"0" w kolumnie 1
	ANDI	A,00111000B		;Aktywna jest "1"-wymaga to zanegowania A
	LD	STAKBD,A		;Maskowanie bitw 7,6 i 2,1,0 i zap.stanu klaw.
	SET	6,COPY_PB		;To samo dla kolumny 2
	RES	7,COPY_PB
	LD	A,COPY_PB
	LD	DRB,A
	LD	A,DRB
	COM	A
	ANDI	A,00111000B		;Maskowanie bitw i odczyt przebiega podobnie,
	RLC	A			;jednak naley przesun bity w prawo tak,aby
	RLC	A			;b3=b0 itp.
	RLC	A
	RLC	A
	RLC	A
	RLC	A
	ADD	A,STAKBD		;Sumowanie odczytw
	LD	STAKBD,A		;Zapamitanie stanu klawiatury
	SET	7,COPY_PB		;Odtworzenie stanu DRB
	LD	A,COPY_PB
	LD	DRB,A
	RET


;Reakcja na nacinicie klawisza
AKCJA	LDI	WDR,0FEH		;Zabezpieczenie przed RESET'em przez ukad Watchdog'a
	LD	A,STAKBD
	JRNZ	AKC_1			;Jeli wcinito jaki klawisz to akcja(STAKBD<>0)
	CLR	LOOPCNT			;Jeli nie nacinito klawisza licznik wej do obsugi
	RET				;klawiatury zostaje wyzerowany
AKC_1	RES	6,STAPRG		;Zaczenie wywietlacza
;Zaczanie/wyczanie przekanika
	INC	LOOPCNT			;Zwiksz licznik wej do obs.klawiatury
	CLR	SECSCNT			;Licznik pauzy zaczyna zliczanie od 0
	CPI	A,ON_OFF
	JRNZ	AKC_2
	CALL	NEGON
	RET
;Dodawanie minut do czasu zegara/programu
AKC_2	CPI	A,PLUS
	JRNZ	AKC_3
	CALL	ADDMIN
	SET	4,STAPRG		;Ustawienie bitu uniemoliwiajcego zadziaanie zacze
	RET				;podczas ustawiania czasu zegara
;Odejmowanie minut od czasu zegara/programu
AKC_3	CPI	A,MINUS
	JRNZ	AKC_4
	CALL	SUBMIN
	SET	4,STAPRG		;Tak samo jak wyej
	RET
;Uaktywnienie ustawiania programu 1
AKC_4	CPI	A,PROG_1
	JRNZ	AKC_5
	RES	5,STAPRG		;Umoliwienie wyczenia przez procedur alarm
	CALL	SETPRG1
	RET
;Uaktywnienie ustawiania programu 2
AKC_5	CPI	A,PROG_2
	JRNZ	AKC_6
	RES	5,STAPRG		;Umoliwienie wyczenia przez procedur alarm
	CALL	SETPRG2
	RET
;Uaktywnienie ustawiania zegara
AKC_6	CPI	A,CLOCK
	CALL	SETCLK
	LD	A,LOOPCNT		;Po duszym przytrzymaniu klawisza "CLOCK"
	SUBI	A,DELAY2		;wczenie wywietlania sekund
	JRC	AKC_7
	CALL	DISPSEC
AKC_7	RET


;Wywietlanie/ustawianie programu 1
SETPRG1	LD	A,LOOPCNT
	CPI	A,DELAY1		;Wejcie do nastaw po eliminacji drga klawisza
	JRZ	SPRG1_D			;(metod zliczania kilku kolejnych wej co jest
	RET				;rwnowane przytrzymaniu klawisza)
SPRG1_D	JRR	1,ONDISP,SPRG1_2
	JRS	0,STAPRG,SPRG1_0
	SET	0,STAPRG		;program 1 aktywny
	RES	2,STAPRG		;ustawiona 1h (LED PROG.1 wieci)
	RET
SPRG1_0	JRS	2,STAPRG,SPRG1_1
	SET	2,STAPRG		;ustawienie 0,5h (LED PROG.1 pulsuje)
	RET
SPRG1_1	RES	0,STAPRG		;dezaktywacja progr.1
	RES	2,STAPRG
	RET
SPRG1_2	CLR	ONDISP			;< I-SZE WEJCIE
	SET	1,ONDISP		;wyw.nastaw progr.1
	SET	1,STALED		;za.diody progr.1
	RES	2,STALED		;wy.diody progr.2
	RET


;Wywietlanie/ustawianie programu 2
SETPRG2	LD	A,LOOPCNT		;Funkcjonalnie identyczna z powysz procedur z tym,
	CPI	A,DELAY1		;e nastawy dotycz programu 2
	JRZ	SPRG2_D
	RET
SPRG2_D	JRR	2,ONDISP,SPRG2_2
	JRS	1,STAPRG,SPRG2_0
	SET	1,STAPRG		;program 2 aktywny
	RES	3,STAPRG		;ustawiona 1h
	RET
SPRG2_0	JRS	3,STAPRG,SPRG2_1
	SET	3,STAPRG
	RET
SPRG2_1	RES	1,STAPRG
	RES	3,STAPRG
	RET
SPRG2_2	CLR	ONDISP
	SET	2,ONDISP
	RES	1,STALED
	SET	2,STALED
	RET

;Wywietlanie/ustawianie zegara
SETCLK	CLR	ONDISP
	SET	0,ONDISP
	RES	1,STALED
	RES	2,STALED
	RET

;Wywietlanie sekund
DISPSEC	CLR	ONDISP
	SET	3,ONDISP
	RES	1,STALED
	RES	2,STALED
	RET

;Negowanie bitu ZACZONY/WYCZONY w STALED
NEGON	LD	A,LOOPCNT
	CPI	A,DELAY1		;TYLKO RAZ W DANYM CYKLU!!!
	JRZ	NEGON_0
	RET
NEGON_0	JRR	3,STALED,NEGON_1
	RES	3,STALED
	RES	5,STAPRG		;Umoliwienie wyczenia przez procedur alarm
	RET
NEGON_1	SET	3,STALED
	SET	5,STAPRG
	RET


;Dodawanie minut do aktualnie wywietlanego czasu (P1,P2,CLOCK)
ADDMIN	JRR	0,ONDISP,ADDM_I		;Przerwania wyczone tylko dla +/- CLOCK
	CLR	IOR
ADDM_I	LD	A,LOOPCNT		;Gdy DELAY1 zwikszenie o 1
	CPI	A,DELAY1
	JRZ	ADDM_0
	CPI	A,DELAY2		;Nastpne zwikszenia po wejciu nr.DELAY2
	JRNC	ADDM_C			;Gdy LOOPCNT>DELAY2 wczona zostaje funkcja AUTOREPEAT
	JP	IRQSTAR
ADDM_C	LDI	LOOPCNT,DELAY2		;Dla uniknicia przepenienia licznika LOOPCNT
ADDM_0	JRR	0,ONDISP,ADDM_1		;Jeli wywietlany jest zegar,
	CALL	ADD_AKT			;to zwiksz czas aktualny
	JP	IRQSTAR			;Uruchomienie nowego cyklu odliczania (sekundy od 0)
ADDM_1	JRR	1,ONDISP,ADDM_2		;Jeli wywietlany jest program 1,
	CALL	ADD_AL1			;to zwiksz czas programu 1
	JP	IRQSTAR			;Powrt z procedury bez nowego odliczania czasu akt.
ADDM_2	JRR	2,ONDISP,IRQSTAR	;Powrt z proc.jeeli progr.2 nie jest aktywny
	CALL	ADD_AL2			;Jeli wywietlany jest program 2,to ...
	JP	IRQSTAR			;Powrt z procedury bez nowego odliczania czasu akt.
	
;Odejmowanie minut od aktualnie wywietlanego czasu (P1,P2,CLOCK)
SUBMIN	JRR	0,ONDISP,SUBM_I		;Przerwania wyczone tylko dla +/- CLOCK
	CLR	IOR
SUBM_I	LD	A,LOOPCNT		;Gdy ptla numer DELAY1 zmniejszenie o 1
	CPI	A,DELAY1
	JRZ	SUBM_0
	CPI	A,DELAY2		;Nastpne zmniejszenia po wejciu DELAY2
	JRNC	SUBM_C
	JP	IRQSTAR
SUBM_C	LDI	LOOPCNT,DELAY2
SUBM_0	JRR	0,ONDISP,SUBM_1
	CALL	SUB_AKT
	JP	IRQSTAR
SUBM_1	JRR	1,ONDISP,SUBM_2
	CALL	SUB_AL1
	JP	IRQSTAR
SUBM_2	JRR	2,ONDISP,IRQSTAR
	CALL	SUB_AL2
	JP	IRQSTAR

;Wczenie przerwa,inicjacja nowego odliczania
IRQSTAR	JRR	0,ONDISP,IRQST_1
	LDI	TCR,07DH		;Rozpoczcie nowego odliczania (dla funkcji ZEGAR-
	RES	7,TSCR			;-inaczej tylko wykonanie rozkazu RET)
	LDI	IOR,70H
IRQST_1	RET


;Zwikszanie czasu aktualnego
ADD_AKT	CLR	SECAKT
	INC	MINAKT			;Zwikszenie licznika minut
	LD	A,MINAKT		;Czy to ju 60 minut(godzina)?
	CPI	A,60
	JRZ	AAKT_1			;Jeli tak,to zwiksz licznik godzin
	RET
AAKT_1	CLR	MINAKT			;Skasuj licznik minut
	INC	HOURAKT			;Zwiksz licznik godzin
	LD	A,HOURAKT		;Czy miny ju 24 godziny(doba)?
	CPI	A,24
	JRZ	AAKT_2			;Jeli tak,zacznij zliczanie od nowa
	RET
AAKT_2	CLR	HOURAKT
	RET

;Odejmowanie minut od aktualnie wywietlanego czasu (P1,P2,CLOCK)
SUB_AKT	CLR	SECAKT
	LD	A,MINAKT
	SUBI	A,1			;Zmniejszenie licznika minut
	JRC	SAKT_1			;Jeli minuty=0,to zmniejsz licznik godzin
	LD	MINAKT,A
	RET
SAKT_1	LDI	MINAKT,59		;Odtwrz licznik minut
	LD	A,HOURAKT
	SUBI	A,1			;Zmniejsz licznik godzin
	JRC	SAKT_2			;Jeli godziny=0,zacznij odejmowanie od nowa
	LD	HOURAKT,A
	RET
SAKT_2	LDI	HOURAKT,23
	RET

;J.w. dla alarmu 1
ADD_AL1	INC	MINAL1
	LD	A,MINAL1
	CPI	A,60
	JRZ	AAL_1
	RET
AAL_1	CLR	MINAL1
	INC	HOURAL1
	LD	A,HOURAL1
	CPI	A,24
	JRZ	AAL_2
	RET
AAL_2	CLR	HOURAL1
	RET

SUB_AL1	LD	A,MINAL1
	SUBI	A,1
	JRC	SAL_1
	LD	MINAL1,A
	RET
SAL_1	LDI	MINAL1,59
	LD	A,HOURAL1
	SUBI	A,1
	JRC	SAL_2
	LD	HOURAL1,A
	RET
SAL_2	LDI	HOURAL1,23
	RET


;J.w. dla alarmu 2
ADD_AL2	INC	MINAL2
	LD	A,MINAL2
	CPI	A,60
	JRZ	AALR_1
	RET
AALR_1	CLR	MINAL2
	INC	HOURAL2
	LD	A,HOURAL2
	CPI	A,24
	JRZ	AALR_2
	RET
AALR_2	CLR	HOURAL2
	RET

SUB_AL2	LD	A,MINAL2
	SUBI	A,1
	JRC	SALR_1
	LD	MINAL2,A
	RET
SALR_1	LDI	MINAL2,59
	LD	A,HOURAL2
	SUBI	A,1
	JRC	SALR_2
	LD	HOURAL2,A
	RET
SALR_2	LDI	HOURAL2,23
	RET


;Sprawdzanie stanu wycznika czasowego
ALARM	LDI	WDR,0FEH		;Zabezpieczenie przed RESET'em przez ukad Watchdog'a
	CALL	ALRON			;Sprawdzenie czy wczy
	CALL	ALROFF			;Sprawdzenie czy wyczy
	RET


;Wczenie programu o danej godzinie
ALRON	JRS	0,STAPRG,ALRON1
ALRON_A	JRS	1,STAPRG,ALRON2
	RET
					;Reakcja na program 1
ALRON1	LD	A,SECAKT		;Sekundy wprowadzono po to,aby moliwe byo w/wy
	JRZ	ALON1_1			;klawiszem z/w,inaczej nie mona byo zmieni stanu PA7
	JP	ALRON_A			;przez okres 1 minuty tzn.do czasu gdy warunek za/wy
ALON1_1	LD	A,HOURAL1		;przestawa by speniony
	SUB	A,HOURAKT		;Porwnanie godzin zaczenia programu 1
	JRZ	ALON1_2
	JP	ALRON_A
ALON1_2	LD	A,MINAL1
	SUB	A,MINAKT		;Porwnanie minut zaczenia programu 1
	JRZ	ALON1_3
	JP	ALRON_A
ALON1_3	SET	3,STALED		;Jeli warunki spenione porednie ustawienie bitu PA7
	JP	ALRON_A
					;Reakcja na program 2	
ALRON2	LD	A,SECAKT		;Rola sekund j.w.
	JRZ	ALON2_1
	RET
ALON2_1	LD	A,HOURAL2
	SUB	A,HOURAKT		;Porwnanie godzin zaczenia programu 2
	JRZ	ALON2_2
	RET
ALON2_2	LD	A,MINAL2
	SUB	A,MINAKT		;Porwnanie minut zaczenia programu 2
	JRZ	ALON2_3
	RET
ALON2_3	SET	3,STALED
	RET

;Wyczenie programu o danej godzinie(czas do wylaczenia=1 godzina)
;Organizacja proc.identyczna z zaczajc za wyjtkiem godzin wyczenia,
;ktre s wyliczane jako czas zaczenia+1 godzina
ALROFF	LDI	WDR,0FEH
	JRS	5,STAPRG,ALRRET		;Jeeli ustawiony jest STAPRG(5) procedurze nie wolno
	JRS	0,STAPRG,ALROFF1	;wycza urzdzenia-wczenie rczne!
ALOFF_A	JRS	1,STAPRG,ALROFF2
ALRRET	RET

;Wyczenie programu 1
ALROFF1	LD	A,SECAKT		;Warunek wprowadzony po to,aby mona byo natychmiast
	JRZ	ALOFF1			;wyczy urzdzenie nie czekajc na upyw 1 minuty
	JP	ALOFF_A

ALOFF1	JRS	2,STAPRG,AL1_1	;Wyliczenie godzin wycze w zalenoci od STAPRG(2)
	CALL	AL1_1H
	JP	AL1_2
AL1_1	CALL	AL1_05H
AL1_2	LD	A,HOFFAL1		;(wyczenie programu 1)
	SUB	A,HOURAKT
	JRZ	AL1_3
	JP	ALOFF_A
AL1_3	LD	A,MOFFAL1
	SUB	A,MINAKT
	JRZ	AL1_4
	JP	ALOFF_A
AL1_4	RES	3,STALED
	JP	ALOFF_A
	
;Wyczenie programu 2
ALROFF2	LD	A,SECAKT
	JRZ	ALOFF2
	RET
ALOFF2	JRS	3,STAPRG,AL2_1		;Wyliczenie godzin wycze w zalenoci od STAPRG(3)
	CALL	AL2_1H
	JP	AL2_2
AL2_1	CALL	AL2_05H
AL2_2	LD	A,HOFFAL2		;(wyczenie programu 2)
	SUB	A,HOURAKT
	JRZ	AL2_3
	RET
AL2_3	LD	A,MOFFAL2
	SUB	A,MINAKT
	JRZ	AL2_4
	RET
AL2_4	RES	3,STALED
	RET

;Wyliczenie godzin wycze dla alarmu 1(HOFFAL1,MOFFAL1)
AL1_1H	LD	A,MINAL1
	LD	MOFFAL1,A		;Zachowujemy minuty wyczenia
	LD	A,HOURAL1		;Godzin wyczenia zwikszamy o 1
	INC	A
	CPI	A,24			;Jeli godzina wyczenia=24,to godz.wy<-0
	JRNZ	AL1_1H1
	CLR	A
AL1_1H1	LD	HOFFAL1,A		;Zachowanie wyliczonej godziny wyczenia
	RET

AL1_05H	LD	A,MINAL1
	ADDI	A,30			;Do minut alarmu dodajemy 30 minut do wyczenia
	SUBI	A,60			;Czy MINAL1+30 >= 60?
	JRNC	AL1_5H1			;Jeli tak,to naley zwikszy godziny
	ADDI	A,60			;Jeli nie,to przywracamy wyliczon warto minut
	LD	MOFFAL1,A		;Zachowujemy minuty wyczenia PROGR.1
	LD	A,HOURAL1		;Zachowujemy godzin wyczenia PROGR.1
	LD	HOFFAL1,A
	RET
AL1_5H1	LD	MOFFAL1,A		;Zapamitanie minut wyczenia PROGR.1
	LD	A,HOURAL1		;Wyliczenie godziny wyczenia PROGR.1
	INC	A
	CPI	A,24
	JRNZ	AL1_5H2
	CLR	A
AL1_5H2	LD	HOFFAL1,A		;Zachowujemy godzin wyczenia PROGR.1
	RET
	RET

;Wyliczenie godzin wycze dla alarmu 2(HOFFAL2,MOFFAL2)
AL2_1H	LD	A,MINAL2
	LD	MOFFAL2,A		;Zachowujemy minuty wyczenia PROGR.2
	LD	A,HOURAL2		;Godzin wyczenia  PROGR.2 zwikszamy o 1
	INC	A
	CPI	A,24			;Jeli godzina wyczenia=24,to godz.wy=0
	JRNZ	AL2_1H1
	CLR	A
AL2_1H1	LD	HOFFAL2,A		;Zachowanie wyliczonej godziny wyczenia PROGR.2
	RET

AL2_05H	LD	A,MINAL2
	ADDI	A,30			;Do minut alarmu dodajemy 30 minut do wyczenia
	SUBI	A,60			;Czy MINAL1+30 >= 60?
	JRNC	AL2_5H1			;Jeli tak,to naley zwikszy godziny
	ADDI	A,60			;Jeli nie,to przywracamy wyliczon warto minut
	LD	MOFFAL2,A		;Zachowujemy minuty wyczenia PROGR.2
	LD	A,HOURAL2		;Zachowujemy godzin wyczenia PROGR.2
	LD	HOFFAL2,A
	RET
AL2_5H1	LD	MOFFAL2,A		;Zapamitanie minut wyczenia PROGR.2
	LD	A,HOURAL2		;Wyliczenie godziny wyczenia PROGR.2
	INC	A
	CPI	A,24
	JRNZ	AL2_5H2
	CLR	A
AL2_5H2	LD	HOFFAL2,A		;Zachowujemy godzin wyczenia PROGR.2
	RET

;Czyszczenie pamici RAM
CLRRAM	LDI	X,084H			;Do x adres pocztkowy pamici ram
CLRRAM0	LD	A,X
	CPI	A,0C0H			;Do y adres kocowy pamici ram+1
	JRNZ	CLRRAM1
	RET
CLRRAM1	CLR	A
	LD	(X),A
	INC	X
	JP	CLRRAM0


.END
